%% Initialization variables
clear all; clc;close all;

beam_lengh_um = 136.5;
beam_lengh_pixels = 111;
um_per_pixel=beam_lengh_um/beam_lengh_pixels;

%number of data files containing samples of data
number_of_samples =10;



%read first file to determine size

sample_location1 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 1\img01.xlsx';
sample_location2 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 2\img1.xlsx';
sample_location3 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 032509 3\img1.xlsx';
sample_location4 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 033009 4\img1.xlsx';
sample_location5 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 5\img1.xlsx';
sample_location6 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 6\img1.xlsx';

sample_location = sample_location5;

sample1 = xlsread(sample_location);
[rows_data,cols_data] = size(sample1);

%location of the data files
data_location1 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 1\img0';
data_location2 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 2\img';
data_location3 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 032509 3\img';
data_location4 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 033009 4\img';
data_location5 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 5\img';
data_location6 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 6\img';

data_location = data_location5;

%location of the temperature data file
temp_data_location2 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 2\temperature_readings.xlsx';
temp_data_location3 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 032509 3\temperature_readings.xlsx';
temp_data_location4 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 033009 4\temperature_readings.xlsx';
temp_data_location5 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 5\temperature_readings.xlsx';
temp_data_location6 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 6\temperature_readings.xlsx';

temp_data_location = temp_data_location5;
%read temperature of samples in ohms
temperature_Kohms = xlsread(temp_data_location);
%convert to degrees C from Kohms using this equaiton
%0.000000006*x^6 - 0.000002*x^5 + 0.0002*x^4 - 0.0108*x^3 + 0.3572*x^2 - 7.1184*x + 69.736
f1 = inline('0.000000006*x.^6 - 0.000002*x.^5 + 0.0002*x.^4 - 0.0108*x.^3 + 0.3572*x.^2 - 7.1184*x + 69.736');
f2 = inline('x');
f = f2;
temperature_deg = f(temperature_Kohms);


%functuion to handle the desired naming scheme of the files
getName = @(num)IntToStr1(num,data_location);

%matrix to store all the data
beams_data_1 = zeros(rows_data,number_of_samples);
beams_data_2 = zeros(rows_data,number_of_samples);
beams_data_3 = zeros(rows_data,number_of_samples);
beams_data_mean = zeros(rows_data,number_of_samples);

legs_data_1 = zeros(rows_data,number_of_samples);
legs_data_2 = zeros(rows_data,number_of_samples);
legs_data_3 = zeros(rows_data,number_of_samples);
legs_data_mean = zeros(rows_data,number_of_samples);

current_sample = zeros(rows_data,cols_data);


%% read data
for i = 1:1:number_of_samples
    %generate new location name
    current_location = getName(i);
    %read file
    current_sample = xlsread(current_location);
    %extract beams displacement information
    beams_data_1(:,i) = current_sample(:,2);
    beams_data_2(:,i) = current_sample(:,3);
    %beams_data_3(:,i) = current_sample(:,4);
    %generate beams average displacement information
    beams_data_mean(:,i) = (beams_data_1(:,i)+ beams_data_2(:,i))/2; %+beams_data_3(:,i))/3;
 
    %extract legs displacement information
    legs_data_1(:,i) = current_sample(:,1);
    legs_data_2(:,i) = current_sample(:,4);
    %legs_data_3(:,i) = current_sample(:,6);
    %generate legs average displacement information
    legs_data_mean(:,i) = (legs_data_1(:,i)+ legs_data_2(:,i))/2; % + legs_data_3(:,i))/3;
       
end

%data = cat(2,beams_data,legs_data);

%% read beam locations

beam_locations_data2 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 2\Beam boarders.xlsx';
beam_locations_data3 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 032509 3\Beam boarders.xlsx';
beam_locations_data4 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 033009 4\Beam boarders.xlsx';
beam_locations_data5 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 5\Beam boarders.xlsx';
beam_locations_data6 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Data 040309 6\Beam boarders.xlsx';

beam_locations_data = beam_locations_data5;

%read temperature of samples in ohms
beam_locations = xlsread(beam_locations_data);

%% extract the particular beam data

close all;
%parameters for filtering the data of only one beam
beam_location = 1;
current_beam_location = beam_locations(beam_location,:);

start_of_beam = current_beam_location(1,1);
end_of_beam = current_beam_location(1,2);
beam_range = end_of_beam - start_of_beam +1;

start_of_leg = end_of_beam;
end_of_leg = current_beam_location(1,3);
leg_range = end_of_leg - start_of_leg +1;

total_range = beam_range+leg_range;
total_beam_range = 1:1:total_range;
total_beam_range = total_beam_range';

range_mid = int32((beam_range+leg_range)/2);


beam_data = zeros(beam_range,number_of_samples);
leg_data = zeros(leg_range,number_of_samples);

for i = 1:1:number_of_samples
    beam_data(:,i) = beams_data_mean(start_of_beam:end_of_beam,i);
    leg_data(:,i) = legs_data_mean(start_of_leg:end_of_leg,i);
end


data_beam_raw = cat(1,beam_data,leg_data);

 %% line up all of the beam instances
%************************************************************************

data_beam = data_beam_raw;
%read position of the beginning of each beam instance
offset = data_beam((beam_range+leg_range),:);
%offset data
for i = 1:1:number_of_samples
    data_beam(:,i) = data_beam(:,i) - offset(1,i);
end

%read the beam tip positions
beam_tip_disp = data_beam(1,:);

%reoriend the beams so that the base is on the left
data_beam = flipud(data_beam);


 %% Fit data and calculate displacement
%************************************************************************

%generate x range for the lenght of the beam
x_range_pixels = total_beam_range;
x_range_um = (x_range_pixels-1)*um_per_pixel;

%generate x range for the degees
x_range_deg = temperature_deg;
x_range_deg_min = min(x_range_deg(:,1));
x_range_deg_delta = x_range_deg(:,1) - x_range_deg_min;


beam_tip_fit = zeros(number_of_samples,1);
beam_fit = zeros(total_range,number_of_samples);



%degree of polynomial fit
poly_n = 2;
%position for calculation of displacement
beam_tip_x = max(x_range_um);
% Matrix to store the coefficients for the polynomial fit of the
%deflection of the surface of each beam at each temperature.
all_poly = zeros(number_of_samples,poly_n+1);


for i = 1:1:number_of_samples
    current_poly = polyfit(x_range_um,data_beam(:,i),poly_n);
    all_poly(i,:) = current_poly(1,:);
    beam_tip_fit(i,1) = polyval(current_poly,beam_tip_x);
    for j = 1:1:total_range
        current_x = x_range_um(j,1);
        beam_fit(j,i) = polyval(current_poly,current_x);
    end
end

%line up all of fitted beams*****************
%read position of the beginning of each beam instance
offset = beam_fit(1,:);
%offset data
for i = 1:1:number_of_samples
    beam_fit(:,i) = beam_fit(:,i) - offset(1,i);
end

 %% fit final data
%************************************************************************
lin_p = polyfit(x_range_deg_delta,beam_tip_fit,1);
beam_tip_fit_linear = polyval(lin_p,x_range_deg_delta);
fprintf(' \n');
fprintf('\n Beam number: %g \n', beam_location);
fprintf('Fitted data coefficients: \n');
fprintf(' %g \n', lin_p);

 %% offset fit and refit data
%************************************************************************
beam_tip_fit_linear_max = max(beam_tip_fit_linear);
beam_tip_fit_offsetted = beam_tip_fit_linear - beam_tip_fit_linear_max;


lin_p_offsetted = polyfit(x_range_deg_delta,beam_tip_fit_offsetted,1);
beam_tip_fit_linear_offsetted = polyval(lin_p_offsetted,x_range_deg_delta);
fprintf(' \n');
fprintf('\n Beam number: %g \n', beam_location);
fprintf('Refitted data coefficients: \n');
fprintf(' %g \n', lin_p_offsetted);

 %% Computational results

computational_data_location1 = 'C:\ALL\School\MQP\Beams sensitivity\Deflection readings\Computational data\Computational_data.xlsx';
computational_data_location = computational_data_location1;

%read temperature of samples in ohms
computational_data = xlsread(computational_data_location);

%offset between the beam beginning location of the computational and the
%experimental data [um]
computational_offset = (beam_lengh_um - max(x_range_um))/2;
%find the max of the data
x_range_um_computational_max = max(x_range_um) + computational_offset;
%get the size
computational_data_size = size(computational_data,1);
%generate a x range with the give size
step_x_comp =x_range_um_computational_max /computational_data_size;
x_range_um_computational = 0:step_x_comp:x_range_um_computational_max;

%fit equation for the thermal sensitivity of the beam with respect to its lenght
computational_data_poly = polyfit(computational_data(:,1),computational_data(:,2),2);

computational_data_defl_per_deg_offset = polyval(computational_data_poly, computational_offset);
computational_data_defl_per_deg = polyval(computational_data_poly, x_range_um_computational_max);
computational_data_defl_per_deg = computational_data_defl_per_deg + computational_data_defl_per_deg_offset;
fprintf(' \n');
fprintf('Computational data slope: \n');
fprintf(' %g \n', computational_data_defl_per_deg);

%beam_tip_disp_computational_func = computational_data_defl_per_deg*x_range_deg_delta;   % inline('-0.1059*x-1*10^(-7)');
beam_tip_disp_computational = -computational_data_defl_per_deg*x_range_deg_delta;


 %% plot data
%**************************************************************************
close all;
sample_set =4;
range = start_of_beam:1:end_of_leg;
x_dummy = 1:1:rows_data;

figure(1)
plot(x_dummy,beams_data_mean(:,sample_set),'r');
str1(1) = {'\bullet\leftarrow Beginning of beam data'};
text1_x_pos = start_of_beam;
text1_y_pos = beams_data_mean(text1_x_pos,sample_set);
text(text1_x_pos,text1_y_pos,str1);
str2(1) = {'\bullet\leftarrow End of beam data'};
text2_x_pos = end_of_beam;
text2_y_pos = beams_data_mean(text2_x_pos,sample_set);
text(text2_x_pos,text2_y_pos,str2);
str3(1) = {'\bullet\leftarrow End of leg data'};
text3_x_pos = end_of_leg;
text3_y_pos = legs_data_mean(text3_x_pos,sample_set);
text(text3_x_pos,text3_y_pos,str3);

hold on
plot(x_dummy,legs_data_mean(:,sample_set),'g');
xlabel('X position along the sample [pixels]');
ylabel('Y position [um]');
title('raw data - full');

h = legend('Beams data','Legs data',1);
set(h,'Interpreter','none')
grid on
axis tight



figure(2)
plot(x_dummy(range),beams_data_mean(range,sample_set),'r');
hold on
plot(x_dummy(range),legs_data_mean(range,sample_set),'g');
grid on
xlabel('X position along the sample [pixels]');
ylabel('Y position [um]');
title('beam and leg raw data');

h = legend('Beam data','Leg data',1);
set(h,'Interpreter','none')
axis tight

figure(3)
plot(x_range_um,flipud(data_beam_raw));
grid on
xlabel('X position along the sample [pixels]');
ylabel('Y position [um]');
title('Curvature of selected beam at each temperature - raw data');
axis tight

figure(4);
plot(x_range_um,data_beam);
xlabel('X position along the beam [um]');
ylabel('Displacement [um]');
title('Curvature of selected beam at each temperature - offsetted raw data ');
grid on
axis tight


figure(5);
plot(x_range_um,beam_fit);
xlabel('X position along the beam [um]');
ylabel('Displacement [um]');
title('Curvature of selected beam at each temperature - fitted data ');
grid on
axis tight

beam_instance = 2;

figure(6);
plot(x_range_um,beam_fit(:,beam_instance), x_range_um,data_beam(:,beam_instance));
xlabel('X position along the beam [um]');
ylabel('Displacement [um]');
title('Curvature of selected beam at each temperature - fitted and offsetted raw data ');
grid on
axis tight

figure(7);
plot(x_range_deg_delta,beam_tip_disp,x_range_deg_delta,beam_tip_fit,'g',x_range_deg_delta,beam_tip_fit_linear,'r');
xlabel('Change in temp [Deg C]') ;
ylabel('Displacement [um]');
title('Displacement vs change in temperature');
h = legend('beam tip disp raw data','beam tip disp fitted data','beam tip disp fitted data linear approximation',1);
set(h,'Interpreter','none')
grid on
axis tight

figure(8);
plot(x_range_deg_delta,beam_tip_disp_computational,'-+r',...
    x_range_deg_delta,beam_tip_fit_linear_offsetted);
xlabel('Change in temp [Deg C]') ;
ylabel('Displacement [um]');
title('Displacement vs change in temperature - comparison of methods');
h = legend('computational method','analytical method','experimental method',1);
set(h,'Interpreter','none')
grid on
axis tight




