%% Initialization variables
% clear all; clc;close all;

%Upper and lower border of voltage range
Down_range = V_min_next;
Up_range = V_max_next;
%Voltage range
range = Up_range - Down_range;
%voltage step
Voltage_step =min_step_next;
%voltage samples
Voltage = Down_range:Voltage_step:Up_range;

% bit_range = 0:1:255;
%Number of sets of samples
sets = round(range/Voltage_step+1); 
%Number of frames per sample
% frames = 5;

% %location of the files
% location1 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 1\IMG_0001_';
% location2 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 2\IMG_0001_';
% location3 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 3\IMG_0001_';
% location4 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 4\IMG_0001_';
% location5 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 5\IMG_0001_';
% location6 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 6\IMG_0001_';
% location7 ='C:\ALL\School\MQP\PZ mapping\Accuracy test 1 020609\data 020609 7\IMG_0001_';
% 
% 
% location=location1;

%minimum for the absolute value of the denominator in the cosine formula
% cos_min = 0.01;

%iterator for the names of the files
% name=0;
%max number of digits for the naming of the files
% max_name = 4;

%fucntion for creating names of type IMGnumberOfPic
num2name = @(num)IntToStr(num,max_name,location);

%fucntion for creating names of  type test0001_voltageSet_stepNumber
num2name2 = @(num)IntToStr2(num,frames, location, Voltage_step,Down_range);

%functuion to handle the desired naming scheme of the files
getName = @(num)num2name2(num);


rgbToGray = @(rgb_pic)RGBtoGray(rgb_pic);


%str iterator for the names of the files
str_name = getName(name);

%reads the first image to measure the size of the image so that it can
%preallocate space. It assumes that all the images are the same.
raw_pic = imread(str_name);  %reads first image
[rows_pix,cols_pix,depth] = size(raw_pic);  %reads size of images

%viewing area parameters
Col_start = int32(0.45*cols_pix);
Col_end = int32(0.55*cols_pix);
Col_range = Col_end-Col_start+1;

Row_start = int32(0.05*rows_pix);
Row_end = int32(0.95*rows_pix);
Row_range = Row_end-Row_start+1;

%% Read data

%allocate space for a matrix to hold the intensities and phase shifts 
%of the several measurements
I=zeros(Row_range,Col_range,frames); %temporary stores intensities of a sample of frames
I_data=zeros(Row_range,Col_range,frames, sets); 

I_1=zeros(Row_range,Col_range);
I_2=zeros(Row_range,Col_range);
I_3=zeros(Row_range,Col_range);
I_4=zeros(Row_range,Col_range);
I_5=zeros(Row_range,Col_range);

cos_alpha_raw = zeros(Row_range,Col_range);
cos_alpha_data_raw = zeros(Row_range,Col_range,sets);


for set = 1:1:sets
    %reads and coverts from RBG to grayscale
    for frame = 1:1:frames
        
         raw_pic = imread(str_name); %read next file
         raw_pic = cast(raw_pic, 'double');%cast to double
         pic = rgbToGray(raw_pic); %covert to gray scale image
         %pic = rgb2gray(raw_pic);
         
         %read intensities of each frame for the particular sample
         I(:,:,frame)=pic(Row_start:Row_end, Col_start:Col_end);
         
         name = name+1; %iterate name of file
         str_name = getName(name); %generate the new name
         
    end;
    
    I_data(:,:,:,set) = I(:,:,:);
   %split intensity data for the particular sample into data for individual frames 
    
         I_1=I(:,:,1);
         I_2=I(:,:,2);
         I_3=I(:,:,3);
         I_4=I(:,:,4);
         I_5=I(:,:,5);
    
  cos_alpha_raw = (I_5-I_1)./(2*(I_4-I_2)); 
  cos_alpha_data_raw(:,:,set) = cos_alpha_raw;
  
end;
%% Preallocate space
Voltage=Voltage';

desired_row = int32(0.5*Row_range);
desired_col = int32(0.5*Col_range);

%******final results data********
alpha_raw_mean = zeros(Row_range,sets);
alpha_raw_mean_avg = zeros(sets,1);
alpha_raw_line = zeros(Row_range,sets);
alpha_raw_line_avg = zeros(sets,1);

% *******All rows mean data************
I_1_mean= zeros(Row_range,1);
I_2_mean= zeros(Row_range,1);
I_3_mean= zeros(Row_range,1);
I_4_mean= zeros(Row_range,1);
I_5_mean= zeros(Row_range,1);
%I_denom_mean = zeros(sets, Row_range);
cos_alpha_raw_mean = zeros(Row_range,sets);
cos_alpha_raw_mean_avg = zeros(sets,1);

% *******Row data************
I_1_line = zeros(Row_range,1);
I_2_line = zeros(Row_range,1);
I_3_line = zeros(Row_range,1);
I_4_line = zeros(Row_range,1);
I_5_line = zeros(Row_range,1);
%I_denom_line=zeros(sets, Row_range);
cos_alpha_raw_line = zeros(Row_range,sets);
cos_alpha_raw_line_avg = zeros(sets,1);

   
%% Calculate


for current_set = 1:1:sets
    % *******All cols mean data************
for current_row = 1:1:Row_range
    I_1_mean(current_row,1)=mean(I_data(current_row,:,1,current_set));
    I_2_mean(current_row,1)=mean(I_data(current_row,:,2,current_set));
    I_3_mean(current_row,1)=mean(I_data(current_row,:,3,current_set));
    I_4_mean(current_row,1)=mean(I_data(current_row,:,4,current_set));
    I_5_mean(current_row,1)=mean(I_data(current_row,:,5,current_set));
end

%I_denom_mean(current_set,:) = I_4_mean(1,:) - I_2_mean(1,:);
cos_alpha_raw_mean(:,current_set) = (I_5_mean(:,1)-I_1_mean(:,1))./(2*(I_4_mean(:,1)-I_2_mean(:,1)));

Counter = 0;
Sum = 0;
Limit = 0;
for i=1:Row_range
    Limit = 1 - abs(cos_alpha_raw_mean(i,current_set));
    if (Limit>cos_min)
        %alpha_raw_mean(current_set,i) = acos(cos_alpha_raw_mean(current_set,i));
        Sum = Sum + cos_alpha_raw_mean(i,current_set);
        Counter = Counter+1;
    end
end
%alpha_raw_mean_avg(current_set,1) = Sum/Counter;
cos_alpha_raw_mean_avg(current_set,1) = Sum/Counter;
Counter = 0;
Sum = 0;

% *******Col data************
I_1_line(:,1)=I_data(:,desired_col,1,current_set);
I_2_line(:,1)=I_data(:,desired_col,2,current_set);
I_3_line(:,1)=I_data(:,desired_col,3,current_set);
I_4_line(:,1)=I_data(:,desired_col,4,current_set);
I_5_line(:,1)=I_data(:,desired_col,5,current_set);

%I_denom_line(current_set,:) = I_4_line(1,:) - I_2_line(1,:);
cos_alpha_raw_line(:,current_set) = (I_5_line(:,1)-I_1_line(:,1))./(2*(I_4_line(:,1)-I_2_line(:,1)));

Counter = 0;
Sum = 0;
Limit = 0;
for i=1:Row_range
    Limit = 1 - abs(cos_alpha_raw_line(i,current_set));
    if (Limit>cos_min)
        %alpha_line_mean(current_set,i) = acos(cos_alpha_line_mean(current_set,i));
        Sum = Sum + cos_alpha_raw_line(i,current_set);
        Counter = Counter+1;
    end
end
%alpha_raw_line_avg(current_set,1) = Sum/Counter;
cos_alpha_raw_line_avg(current_set,1) = Sum/Counter;
Counter = 0;
Sum = 0;
    
    
end
%% Find voltage

%************line*************************

% %Calculate the absolute values
% cos_alpha_raw_line_avg_abs = abs(cos_alpha_raw_line_avg);
% %Extract the point closest to zero as well as its index in the array
% [cos_min,cos_index] = min(cos_alpha_raw_line_avg_abs);
% %look at the real value of the element with that index
% cos_zero_approx = cos_alpha_raw_line_avg(cos_index,1);
% %raw_line_voltage_result = Voltage(cos_alpha_raw_line_avg_index,1);
% 
% %if it is above zero read the next element(below zero) and interpolate
% if (cos_zero_approx>=0) 
%     %check if the next element exists
%     if (cos_index+1>sets)%if not interpolate with the previous element
%         left_cos = cos_alpha_raw_line_avg(cos_index-1,1);
%         left_voltage = Voltage(cos_index-1,1);
%         
%         right_cos = cos_alpha_raw_line_avg(cos_index,1);
%         right_voltage = Voltage(cos_index,1);
%         
%     else%if yes interpolate with the next element
%         left_cos = cos_alpha_raw_line_avg(cos_index,1);
%         left_voltage = Voltage(cos_index,1);
%         
%         right_cos = cos_alpha_raw_line_avg(cos_index+1,1); 
%         right_voltage = Voltage(cos_index+1,1);
%     end
%      
% else
%    %check if the previous element exists
%     if (cos_index-1<0)%if not interpolate with the next element
%         left_cos = cos_alpha_raw_line_avg(cos_index,1);
%         left_voltage = Voltage(cos_index,1);
%         
%         right_cos = cos_alpha_raw_line_avg(cos_index+1,1);
%         right_voltage = Voltage(cos_index+1,1);
%         
%     else%if yes interpolate with the previous element
%         left_cos = cos_alpha_raw_line_avg(cos_index-1,1);
%         left_voltage = Voltage(cos_index-1,1);
%         
%         right_cos = cos_alpha_raw_line_avg(cos_index,1); 
%         right_voltage = Voltage(cos_index,1);
%     end
%      
% end

raw_line_voltage_result = interp1(cos_alpha_raw_line_avg,Voltage,0); 


raw_line_voltage_result_1 = interp1(cos_alpha_raw_line_avg,Voltage,0,'spline');


%************mean*************************

% %Calculate the absolute values
% cos_alpha_raw_mean_avg_abs = abs(cos_alpha_raw_mean_avg);
% %Extract the point closest to zero as well as its index in the array
% [cos_min,cos_index] = min(cos_alpha_raw_mean_avg_abs);
% %look at the real value of the element with that index
% cos_zero_approx = cos_alpha_raw_mean_avg(cos_index,1);
% %raw_line_voltage_result = Voltage(cos_alpha_raw_line_avg_index,1);
% 
% %if it is above zero read the next element(below zero) and interpolate
% if (cos_zero_approx>=0) 
%     %check if the next element exists
%     if (cos_index+1>sets)%if not interpolate with the previous element
%         left_cos = cos_alpha_raw_mean_avg(cos_index-1,1);
%         left_voltage = Voltage(cos_index-1,1);
%         
%         right_cos = cos_alpha_raw_mean_avg(cos_index,1);
%         right_voltage = Voltage(cos_index,1);
%         
%     else%if yes interpolate with the next element
%         left_cos = cos_alpha_raw_mean_avg(cos_index,1);
%         left_voltage = Voltage(cos_index,1);
%         
%         right_cos = cos_alpha_raw_mean_avg(cos_index+1,1); 
%         right_voltage = Voltage(cos_index+1,1);
%     end
%      
% else
%    %check if the previous element exists
%     if (cos_index-1<0)%if not interpolate with the next element
%         left_cos = cos_alpha_raw_mean_avg(cos_index,1);
%         left_voltage = Voltage(cos_index,1);
%         
%         right_cos = cos_alpha_raw_mean_avg(cos_index+1,1);
%         right_voltage = Voltage(cos_index+1,1);
%         
%     else%if yes interpolate with the previous element
%         left_cos = cos_alpha_raw_mean_avg(cos_index-1,1);
%         left_voltage = Voltage(cos_index-1,1);
%         
%         right_cos = cos_alpha_raw_mean_avg(cos_index,1); 
%         right_voltage = Voltage(cos_index,1);
%     end
%      
% end
raw_mean_voltage_result = interp1(cos_alpha_raw_mean_avg,Voltage,0); 

raw_mean_voltage_result_1 = interp1(cos_alpha_raw_mean_avg,Voltage,0,'spline');



%% Calculate parameters for next iteration

%read the result from the previous iteration
V_prev=raw_mean_voltage_result;
min_step_prev = Voltage_step;

%calculate new step size
min_step_next = min_step_prev/step_change_factor;

if (min_step_next<= min_step_absolute)
    
%    return;
end

%calculate the parameters for the new itereation

%calculate the V_min parameter
V_min_next = V_prev*lower_limit;
%rounds down to the nearest min_step multiple
V_min_next = int32(V_min_next/min_step_next);
V_min_next = cast(V_min_next,'double')*min_step_next;

if (V_min_next<=Down_range)
    V_min_next=Down_range;
end


%calculate the V_min parameter
V_max_next = V_prev*upper_limit;
%rounds up to the nearest min_step multiple
V_max_next = int32(V_max_next/min_step_next);
V_max_next = cast(V_max_next,'double')*min_step_next + min_step_next;

if (V_max_next>=Down_range)
    V_max_next=Up_range;
end


%% Print

%*********Print******************************
desired_set = 5;

% *******Col data************
I_1_line(:,1)=I_data(:,desired_col,1,desired_set);
I_2_line(:,1)=I_data(:,desired_col,2,desired_set);
I_3_line(:,1)=I_data(:,desired_col,3,desired_set);
I_4_line(:,1)=I_data(:,desired_col,4,desired_set);
I_5_line(:,1)=I_data(:,desired_col,5,desired_set);

% *******Full raw data************
I_1_raw=I_data(:,:,1,desired_set);
I_2_raw=I_data(:,:,2,desired_set);
I_3_raw=I_data(:,:,3,desired_set);
I_4_raw=I_data(:,:,4,desired_set);
I_5_raw=I_data(:,:,5,desired_set);


%alpha_raw_line_plot = alpha_raw_line(desired_set,:);
%alpha_raw_mean_plot = alpha_raw_mean(desired_set,:);

%I_denom_line_plot = I_denom_line(desired_set,:);
%I_denom_mean_plot = I_denom_mean(desired_set,:);

cos_alpha_raw_line_plot = cos_alpha_raw_line(:,desired_set);
cos_alpha_raw_mean_plot = cos_alpha_raw_mean(:,desired_set);

cos_alpha_data_raw_plot = cos_alpha_data_raw(:,:,desired_set);

Rows = 1:1:Col_range;

%****Print frames data ********

% figure(1)
% %plots for frame 1*************
% subplot(5,3,1)
% plot(I_1_line);
% title('I 1 line');
% axis equal;
% axis tight;
% 
% subplot(5,3,2)
% plot(I_1_mean);
% title('I 1 mean');
% axis equal;
% axis tight;
% 
% subplot(5,3,3)
% mesh(I_1_raw);
% title('I 1 raw');
% axis equal;
% axis tight;
% 
% %plots for frame 2***************
% subplot(5,3,4)
% plot(I_2_line);
% title('I 2 line');
% axis equal;
% axis tight;
% 
% subplot(5,3,5)
% plot(I_2_mean);
% title('I 2 mean');
% axis equal;
% axis tight;
% 
% subplot(5,3,6)
% mesh(I_2_raw);
% title('I 2 raw');
% axis equal;
% axis tight;
% 
% %plots for frame 3************
% subplot(5,3,7)
% plot(I_3_line);
% title('I 3 line');
% axis equal;
% axis tight;
% 
% subplot(5,3,8)
% plot(I_3_mean);
% title('I 3 mean');
% axis equal;
% axis tight;
% 
% subplot(5,3,9)
% mesh(I_3_raw);
% title('I 3 raw');
% axis equal;
% axis tight;
% 
% %plots for frame 4*************
% subplot(5,3,10)
% plot(I_4_line);
% title('I 4 line');
% axis equal;
% axis tight;
% 
% subplot(5,3,11)
% plot(I_4_mean);
% title('I 4 mean');
% axis equal;
% axis tight;
% 
% subplot(5,3,12)
% mesh(I_4_raw);
% title('I 4 raw');
% axis equal;
% axis tight;
% 
% %plots for frame 5*************
% subplot(5,3,13)
% plot(I_5_line);
% title('I 5 line');
% axis equal;
% axis tight;
% 
% subplot(5,3,14)
% plot(I_5_mean);
% title('I 5 mean');
% axis equal;
% axis tight;
% 
% subplot(5,3,15)
% mesh(I_5_raw);
% title('I 5 raw');
% axis equal;
% axis tight;
% %**********histogram******************
% % figure(2);
% % subplot(3,2,1)
% % hist(I_1_raw, bit_range);
% % title('I 1 raw histogram');
% % axis equal;
% % axis tight;
% % 
% % subplot(3,2,2)
% % hist(I_2_raw, bit_range);
% % title('I 2 raw histogram');
% % axis equal;
% % axis tight;
% % 
% % subplot(3,2,3)
% % hist(I_3_raw, bit_range);
% % title('I 3 raw histogram');
% % axis equal;
% % axis tight;
% % 
% % subplot(3,2,4)
% % hist(I_4_raw, bit_range);
% % title('I 4 raw histogram');
% % axis equal;
% % axis tight;
% % 
% % subplot(3,2,5)
% % hist(I_5_raw, bit_range);
% % title('I 5 raw histogram');
% % axis equal;
% % axis tight;
% % 
% % % subplot(3,2,6)
% % % hist(I_data, bit_range);
% % % title('Full data histogram');
% % % axis equal;
% % % axis tight;
% 
% 
% %****Print cos raw oveall data ********
% 
% figure(3)
% 
% mesh(cos_alpha_data_raw_plot);
% title('cos alpha data raw plot');
% %axis equal;
% %axis tight;
% 
% %****Print overall cos data ********
% figure(4)
% 
% % subplot(2,3,1)
% % plot(I_denom_line_plot);
% % title('I denom line');
% % %axis equal;
% % %axis tight;
% 
% subplot(2,1,1)
% plot(cos_alpha_raw_line_plot);
% title('cos alpha raw line');
% grid on;
% %axis equal;
% %axis tight;
% 
% % subplot(2,3,3)
% % plot(cos_alpha_raw_line_avg);
% % title('cos alpha raw line avg');
% % %axis equal;
% % %axis tight;
% 
% 
% % subplot(2,3,4)
% % plot(I_denom_mean_plot);
% % title('I denom mean');
% % %axis equal;
% % %axis tight;
% 
% subplot(2,1,2)
% plot(cos_alpha_raw_mean_plot);
% title('cos alpha raw mean');
% grid on;
% %axis equal;
% %axis tight;
% 
% % subplot(2,3,6)
% % plot(cos_alpha_raw_mean_avg);
% % title('cos alpha raw mean avg');
% % %axis equal;
% % %axis tight;

%****Print final result ********


figure(5)
subplot(2,1,1)
plot(Voltage, cos_alpha_raw_line_avg,'-+g');
hold on 
plot(raw_line_voltage_result,0, '+r');
title('cos alpha raw line avg');
grid on;
%axis equal;
%axis tight;

subplot(2,1,2)
plot(Voltage, cos_alpha_raw_mean_avg,'-+g');%print cos voltage
hold on 
plot(raw_mean_voltage_result,0, '+r');%print cross point
hold on 
plot(V_min_next,0, 'ob');%print new min voltage
hold on 
plot(V_max_next,0, 'ob');%print new max voltage
title('cos alpha raw mean avg');
grid on;
%axis equal;
%axis tight;

%****Print final result ********
% figure(4)
% 
% 
% subplot(1,2,1)
% plot(Voltage,alpha_raw_line_avg);
% title('Voltage vs (alpha raw line avg) for all sets');
% %axis equal;
% %axis tight;
% 
% subplot(1,2,2)
% plot(Voltage,alpha_raw_mean_avg);
% title('Voltage vs (alpha raw mean avg)  for all sets');
% %axis equal;
% %axis tight;
